<?php
// niByLog.RSS plugin 1.1.1 (c) MiMaS 2003

/***config*start*****************************/
// mozna zmieniac ustawienia od tej linii az do ***config*end***

$niByLog_dir = 'nibylog/';
// zmienna wskazujaca polozenie zainstalowanego niByLoga
// sciezka wzgledna

$title = '@blog';
// tytul kanalu RSS
// tekst powinien byc zakodowany w ISO-8859-2
// makro @blog = nazwa bloga z ustawie niByLoga,
// np. $title = '@blog';

$desc_main = 'blog';
// opis kanalu
// tekst powinien byc zakodowany w ISO-8859-2

$desc_len = 50;
// ilosc slow do umieszczenia jako opis pojedynczego wpisu
// wartosc 0 = bez opisu
// wartosc mniejsza od 0 = cay wpis

$desc_slowa = '[... jeszcze @jeszcze @odm_jeszcze]';
// dopisek na koncu wpisu o ilosci slow
// makro @wszystkie = wszystkie slowa
// makro @odm_wszystkie = odmienione slowo 'slowo' (slowo, slow, slowa)
// makro @jeszcze = pozostala ilosc slow
// makro @odm_jeszcze = odmienione slowo 'slowo' (slowo, slow, slowa)
// np. $desc_slowa = '[w sumie @wszystkie @odm_wszystkie, jeszcze @jeszcze]';
// np. $desc_slowa = '[... jeszcze @jeszcze @odm_jeszcze]';

$desc_komentarze = '[@komentarzy @odm_komentarzy]';
// dopisek na koncu wpisu o ilosci komentarzy
// makro @komentarzy = ilosc komentarzy do wpisu
// makro @odm_komentarzy = odmienione slowo 'komentarz' (komentarz, komentarze, komentarzy)
// np. $desc_komentarze = '[@komentarzy @odm_komentarzy]';

$link_main = 'http://serwer.pl/blog/';
// link do strony glownej bloga

$link_post = 'http://serwer.pl/blog/?id=@id';
// link do wpisu
// makro @id = id wpisu
// np. $link_post = 'http://serwer.pl/blog/?id=@id';

$link_comm = 'http://serwer.pl/blog/?cmd=komentator&amp;id=@id';
// link do strony z komentarzami do wpisu
// makro @id = id wpisu
// np. $link_comm = 'http://serwer.pl/blog/?cmd=komentator&amp;id=@id';

$item_count = 10;
// ilosc wpisow do umieszczenia w RSS
// 0 = wszystkie wpisy

$lang = 'pl';
// jezyk w jakim jest prowadzony blog

/***config*end*****************************/

/***the*story*so*far***********************

1.1.1 (2003-11-01)
[+] dodana jawna deklaracja kodowania XML (mimo, ze teoretycznie nie jest
    wymagana poniewaz feed jest kodowany w UTF-8)

1.1.0 (2003-10-22)
[+] jezeli makro %break% znajduje sie w tresci wpisu wczesniej niz limit slow
    wskazany przez $desc_len to wpis jest obcinany na %break%
[+] makro %break% jest usuwane z tresci wpisow
[*] trick do obejscia bledu funkcji iconv()

1.0.3 (2003-10-20)
[*] poprawiona obsluga starych wersji niByLoga (sprzed 1.6.5)

1.0.2 (2003-10-09)
[+] dodane usuwanie tagow z tytulu wpisu
    - w niByLogu mog by tagi HTML w tytule, w RSS, nie
[*] zmienione usuwanie tagow z tytuu i tresci
    - <del> i <ins> zostaja ze wzgledu na ich specyficzny charakter

1.0.1 (2003-09-29)
[!] premiera

1.0.0 (2003-09-23)
[*] wersja testowa

******************************************/

header( "Content-type: text/xml" );

function do_utf( $t )
{
  if ( function_exists('iconv') )
  {
    // quick'n'dirty trick do obejscia bledu iconv()
    // ktora czasem dodaje smieci na koncu tekstu wynikowego
    $r = explode("\t\t", iconv("ISO-8859-2", "UTF-8", $t."\t\t"));
    return $r[0];
  }
  else
  {
    $t = str_replace('', "&#261;", $t);
    $t = str_replace('', "&#263;", $t);
    $t = str_replace('', "&#281;", $t);
    $t = str_replace('', "&#322;", $t);
    $t = str_replace('', "&#324;", $t);
    $t = str_replace('', "&#243;", $t);
    $t = str_replace('', "&#347;", $t);
    $t = str_replace('', "&#380;", $t);
    $t = str_replace('', "&#378;", $t);
    $t = str_replace('', "&#260;", $t);
    $t = str_replace('', "&#262;", $t);
    $t = str_replace('', "&#280;", $t);
    $t = str_replace('', "&#321;", $t);
    $t = str_replace('', "&#323;", $t);
    $t = str_replace('', "&#211;", $t);
    $t = str_replace('', "&#346;", $t);
    $t = str_replace('', "&#379;", $t);
    $t = str_replace('', "&#377;", $t);
    return utf8_encode($t);
  }
}

function odm_slowa( $i )
{
  $s = array( 'sowo', 'sowa', 'sw' );
  if ( $i == 1 ) return $s[0];
  if ( ($i % 10 >= 2) && ($i % 10 < 5) && ($i % 100 < 10 || $i % 100 > 20)) return $s[1];
  return $s[2];
}

function odm_komentarze( $i )
{
  $s = array( 'komentarz', 'komentarze', 'komentarzy' );
  if ( $i == 1 ) return $s[0];
  if ( ($i % 10 >= 2) && ($i % 10 < 5) && ($i % 100 < 10 || $i % 100 > 20)) return $s[1];
  return $s[2];
}

function clear_tags( $t )
{
  $t = strip_tags($t, '<p><blockquote><div><li><td><br><del><ins>');
  $t = str_replace('>', '> ', $t);
  $t = strip_tags($t, '<del><ins>');
  $t = str_replace('del> ', 'del>', $t);
  $t = str_replace('ins> ', 'ins>', $t);
  $t = strtr($t, array_flip(get_html_translation_table(HTML_ENTITIES)));
  $t = str_replace('  ', ' ', $t);
  $t = str_replace('&trade;', '(tm)', $t);
  $t = str_replace('&copy;', '(c)', $t);
  $t = str_replace('<', '&lt;', str_replace('>', '&gt;', $t));
  return $t;
}

if ( isset($niByLog_dir) )
{
  if ( !isset($niByLog_data_folder) )
    require( './'.$niByLog_dir.'config.php' );

  $plik = file($niByLog_data_folder.'/config');
  $config = unserialize(base64_decode($plik[0]));

  if ( file_exists('./'.$niByLog_dir.'_inc/nibylog.inc') )
    require( './'.$niByLog_dir.'_inc/nibylog.inc' );
  else
    require( './'.$niByLog_dir.'nibylog.inc' );

  $blog = CzytajWpisy('ADMIN', 'nibylog');
  $blog_count = count($blog);
  if ( $blog[$blog_count] == '' ) $blog_count--;
  if ( $blog_count < $item_count ) $item_count = $blog_count;
  if ( $item_count == 0 ) $item_count = $blog_count;

  $stare = true;
  if ( function_exists('Wersja') )
  {
    $plik = file( './'.$niByLog_dir.'nibylog.php' );
    eregi("\"(.*)\"", $plik[2], $version);
    eregi("([0-9])[.]([0-9])[.]([0-9])", $version[1], $w);
    $stare = (intval($w[1])*100+intval($w[2])*10+intval($w[3]) < 165);
  }
  else
    $stare = ( count( split( "\t", $blog[0] ) ) <= 5 );
  if ( $stare )
  {         // poniej wersji 1.6.5: 0- id, 1- user, 2- temat, 3- tresc
    $wpis_pos['id'] = 0;
    $wpis_pos['user'] = 1;
    $wpis_pos['temat'] = 2;
    $wpis_pos['tresc'] = 3;
  } else {  // powyzej wersji 1.6.5: 0- id, 1- kategorie, 2- user, 3- temat, 4- tresc
    $wpis_pos['id'] = 0;
    $wpis_pos['kategorie'] = 1;
    $wpis_pos['user'] = 2;
    $wpis_pos['temat'] = 3;
    $wpis_pos['tresc'] = 4;
  }

  echo( '<?xml version="1.0" encoding="UTF-8"?>'."\n" );
  echo( '<rss version="2.0" xmlns:dc="http://purl.org/dc/elements/1.1/">'."\n" );
  echo( "<channel>\n" );
  echo( '<title>'.do_utf(str_replace('@blog',$config['cfg_blog_name'],$title))."</title>\n" );
  echo( '<link>'.$link_main."</link>\n" );
  echo( '<description>'.do_utf($desc_main)."</description>\n" );
  echo( '<language>'.$lang."</language>\n" );
  echo( '<webMaster>'.$config['cfg_admin_email']."</webMaster>\n" );
  echo( "<generator>niByLog.RSS.generator 1.1.1 (c) MiMaS 2003</generator>\n" );
  echo( "<docs>http://blogs.law.harvard.edu/tech/rss</docs>\n" );

  rsort( $blog );
  for ( $ii = 0; $ii < $item_count; $ii++ )
  {
    $wpis = split("\t", $blog[$ii]);

    $wpis_title = do_utf( clear_tags( $wpis[$wpis_pos['temat']] ));

    if ( $desc_len == 0 )
      $wpis_desc = '';
    else
    {
      $wpis_desc = clear_tags( $wpis[$wpis_pos['tresc']] );

      $w = explode('%break%', $wpis_desc);
      $w_do_break = count(explode(' ', $w[0]));
      $wpis_desc = str_replace('%break%', '', $wpis_desc);
      $w_wszystkie= count(explode(' ', $wpis_desc));

      $len = $desc_len;
      if ( $desc_len > $w_wszystkie )
        $len = $w_wszystkie;
      if ( $desc_len > $w_do_break )
        $len = $w_do_break;

      if ( $len > 0 )
      {
        $w = explode(' ', $wpis_desc);
        $wpis_desc = '';
        for ( $ji = 0; $ji < $len; $ji++ )
          $wpis_desc .= $w[$ji].' ';
        if ( ($w_wszystkie > $ji) && ($desc_slowa != '') )
        {
          $dopisek = str_replace('@wszystkie', $w_wszystkie, $desc_slowa);
          $dopisek = str_replace('@odm_wszystkie', odm_slowa($w_wszystkie), $dopisek);
          $dopisek = str_replace('@jeszcze', $w_wszystkie - $ji, $dopisek);
          $dopisek = str_replace('@odm_jeszcze', odm_slowa($w_wszystkie - $ji), $dopisek);
          $wpis_desc .= $dopisek;
        }
      }
      if ( $desc_komentarze != '' )
      {
        $k = 0;
        if ( @filesize($niByLog_data_folder.'/comments/'.$wpis[0]) > 0 )
          $k = count(file($niByLog_data_folder.'/comments/'.$wpis[0]));
        $dopisek = str_replace('@komentarzy', $k, $desc_komentarze);
        $dopisek = str_replace('@odm_komentarzy', odm_komentarze($k), $dopisek);
        $wpis_desc .= $dopisek;
      }
      $wpis_desc = do_utf($wpis_desc);
    }

    $wpis_category = '';
    if ( !$stare && function_exists('CzytajKategorie') )
    {
      $d = CzytajKategorie();
      $wpis_category = do_utf($d[$wpis[$wpis_pos['kategorie']]]);
    }

    echo( "<item>\n" );
    echo( '<title>'.$wpis_title."</title>\n" );
    echo( '<link>'.str_replace('@id', $wpis[0], $link_post)."</link>\n" );
    if ( $wpis_desc != '' )
      echo( '<description>'.$wpis_desc."</description>\n" );
    if ( $wpis_category != '' )
      echo( '<category>'.$wpis_category."</category>\n" );
    if ( $link_comm != '' )
      echo( '<comments>'.str_replace('@id', $wpis[0], $link_comm)."</comments>\n" );
    echo( '<pubDate>'.date("r", $wpis[0])."</pubDate>\n" );
    echo( '<guid isPermaLink="true">'.str_replace('@id', $wpis[0], $link_post)."</guid>\n" );
    echo( '<dc:creator>'.do_utf(WstawPodpis($wpis[$wpis_pos['user']], $config['cfg_podpis'], 0))."</dc:creator>\n" );
    echo( "</item>\n" );
  }
  echo( "</channel></rss>\n" );
}
?>
